import EventEmitter from "wolfy87-eventemitter";

class SubscriptionController extends EventEmitter {
	constructor() {
		super();
		this._canceled = false;
		this._findComplete = false;
	}

	get canceled() {
		return this._canceled;
	}

	set findComplete(value) {
		if(value && !this._findComplete) {
			this._findComplete = true;
			this.emit('find-complete');
		}
	}

	get findComplete() {
		return this._findComplete;
	}

	cancel() {
		if(this.canceled)
			throw new Error('already_canceled');
		else {
			this._canceled = true;
			this.emit('cancel');
			this.removeAllListeners();
		}
	}

	mutation(mutation, doc, seq = null) {
		if(!this.canceled)
			this.emit('mutation', mutation, doc, seq);
	}

	error(error) {
		this.emit('error', error);
	}
}

export default SubscriptionController;
